/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

import com.google.api.client.json.GenericJson;

/**
 * Database instance backup configuration.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BackupConfiguration extends GenericJson {

  /**
   * Whether this configuration is enabled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean enabled;

  /**
   * Identifier for this configuration. This gets generated automatically when a backup
   * configuration is created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * This is always sql#backupConfiguration.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Start time for the daily backup configuration in UTC timezone in the 24 hour format - HH:MM.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String startTime;

  /**
   * Whether this configuration is enabled.
   * The value returned may be {@code null}.
   */
  public Boolean getEnabled() {
    return enabled;
  }

  /**
   * Whether this configuration is enabled.
   * The value set may be {@code null}.
   */
  public BackupConfiguration setEnabled(Boolean enabled) {
    this.enabled = enabled;
    return this;
  }

  /**
   * Identifier for this configuration. This gets generated automatically when a backup
   * configuration is created.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Identifier for this configuration. This gets generated automatically when a backup
   * configuration is created.
   * The value set may be {@code null}.
   */
  public BackupConfiguration setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * This is always sql#backupConfiguration.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * This is always sql#backupConfiguration.
   * The value set may be {@code null}.
   */
  public BackupConfiguration setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Start time for the daily backup configuration in UTC timezone in the 24 hour format - HH:MM.
   * The value returned may be {@code null}.
   */
  public String getStartTime() {
    return startTime;
  }

  /**
   * Start time for the daily backup configuration in UTC timezone in the 24 hour format - HH:MM.
   * The value set may be {@code null}.
   */
  public BackupConfiguration setStartTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

}
